{

script: {
    dir: -1

    // To mimic the jerky motion of the original gnosticene ancient, no
    // velocity component is used. The ancient is run by a series of timers
    // that transition it between states. The OnTick() method simply checks
    // for obstructions and reverses direction.
    //
    // After each Think state, the CheckActive state checks if see if the
    // game is running in the context of the editor. This is so the NPC won't
    // start walking in the editor.

    member CheckActive()
        if !game.editor then
            // schedule the next time to think after 1-5 seconds of walking
            this.SetTimer("Think", 1000 + 4000 * random(), false);
            this.Walk1();
        else
            this.SetTimer("CheckActive", 100, false);
        end if;
    end function

    member Walk1()
        constant SPEED := 6;     // distance per step

        if (this.dir < 0 and (this.entity.isBlockedLeft or !IsFloor(this.entity.left, this.entity.bottom + 1))) or
           (this.dir > 0 and (this.entity.isBlockedRight or !IsFloor(this.entity.right, this.entity.bottom + 1)))
        then
            this.dir := -this.dir;
        end if;

        this.entity.x += SPEED * this.dir;
        this.entity.frame := "ancient-walk-" & (this.dir < 0 ? "left" : "right") & "1";
        this.SetTimer("Walk2", 150, false);
    end function

    member Walk2()
        this.entity.frame := "ancient-walk-" & (this.dir < 0 ? "left" : "right") & "2";
        this.SetTimer("Walk1", 150, false);
    end function

    member Think()
        this.entity.frame := "ancient-think-" & (this.dir < 0 ? "left" : "right");
        this.CancelTimer("Walk1");
        this.CancelTimer("Walk2");
        this.SetTimer("CheckActive", 1000, false);
    end function

    member OnActivateOnTouch()
        game.ancients += 1;
        ExitLevel();
    end function
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

timers: {
    CheckActive: 1            // set the initial timer
}

}