// A specific-use script component used by the Bridge entity to toggle the
// solidity of the bridge when a Switched message is received.
//
// Entity Attribute    Type       Description
// ----------------    -------    -----------
// open                boolean    True if the bridge is open (not solid)
//
{

script: {
    member OnSwitched()
        this.entity.open := !this.entity.open;
    end function

    member OnAttributeChanged(args : map)
        if args.name = "open" then
            this.entity.frame := "bridge-" & (args.value ? "open" : "closed");
            this.entity.solid := !args.value;
        end if;
    end function
}

}