
uniform sampler2D al_tex;
uniform bool      al_use_tex;

varying vec4 varying_color;
varying vec2 varying_texcoord;

void main()
{
    vec4 tex;
    if (al_use_tex)
    {
        tex = texture2D(al_tex, varying_texcoord);
    }
    else
    {
        tex = vec4(1.0, 1.0, 1.0, 1.0);
    }

    gl_FragColor = varying_color * tex;

    // discard all transparent fragments to avoid writing to the depth buffer
    // writing to the depth buffer.
    if (gl_FragColor.a == 0.0)
    {
        discard;
    }
}
