[

// ********************************************************************************************** //
// * ENEMIES                                                                                    * //
// ********************************************************************************************** //

{Entity: "Arachnut"
    Components: {
        Location: {width: 40, height: 40}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "arachnut", frame: "arachnut_run1"}
        LethalToPlayer: {}
        PlayerShotBlocker: {}
    }
    Tool: {
        icon: "arachnut:arachnut_run1"
    }
}

{Entity: "Bounder"
    Components: {
        Location: {width: 24, height: 21}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "bounder", frame: "bounder_up1"}
        PlayerShotBlocker: {}
    }
    Tool: {
        icon: "bounder:bounder_up1"
    }
}

{Entity: "Cloud"
    Components: {
        Location: {width: 64, height: 24}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "cloud", frame: "cloud_aware"}
    }
    Tool: {
        icon: "cloud:cloud_aware"
    }
}

{Entity: "Inchworm"
    Components: {
        Location: {width: 18, height: 16}
        Movement: {vxMax: 140, vyMax: 380, gravity: 768, frictionX: 0, frictionY: 0}
        PlatformClipped: {}
        Visible: {lib: "inchworm", frame: "inchworm_left1"}
        Script: {filename: "inchworm.sv"}
    }
    Tool: {
        icon: "inchworm:inchworm_left1"
    }
}

{Entity: "Lick"
    Components: {
        Location: {width: 22, height: 16}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "lick", frame: "lick_left2"}
        PlayerShotBlocker: {}
    }
    Tool: {
        icon: "lick:lick_left2"
    }
}

{Entity: "Mimrock"
    Components: {
        Location: {width: 24, height: 24}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "mimrock", frame: "mimrock_sit"}
    }
    Tool: {
        icon: "mimrock:mimrock_sit"
    }
}

{Entity: "Mushroom"
    Components: {
        Location: {width: 32, height: 32}
        Collidable: {}
        Movement: {vxMax: 0, vyMax: 380, gravity: 768, frictionX: 0, frictionY: 0}
        PlatformClipped: {}
        Visible: {lib: "mushroom", frame: "mushroom_left1"}
        LethalToPlayer: {}
        PlayerShotBlocker: {}
        Script: {filename: "mushroom.sv"}
        Animation: {}
    }
    Tool: {
        icon: "mushroom:mushroom_left1"
    }
}

{Entity: "Slug"
    Components: {
        Location: {width: 16, height: 24}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "slug", frame: "slug_left1"}
        LethalToPlayer: {}
        PlayerShotBlocker: {}
    }
    Tool: {
        icon: "slug:slug_left1"
    }
}

{Entity: "Snake"
    Components: {
        Location: {width: 16, height: 24}
        Collidable: {}
        PlatformMovement: {}
        PlatformClipped: {}
        Visible: {lib: "snake", frame: "snake_attack_left2"}
    }
    Tool: {
        icon: "snake:snake_attack_left2"
    }
}

{Entity: "Ancient"
    Components: {
        Location: {width: 16, height: 38}
        Collidable: {}
        Movement: {vxMax: 140, vyMax: 380, gravity: 768, frictionX: 0, frictionY: 0}
        PlatformClipped: {}
        PlayerShotBlocker: {}
        Visible: {lib: "sprites", frame: "ancient-think-left"}
        Script: {filename: "ancient.sv"}
    }
    Tool: {
        icon: "sprites:ancient-think-left"
    }
}

{Entity: "ShooterUp"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "shooter_up"}
        Script: {filename: "shooter.sv", script: {bullet: "DartUp", bulletY: -14, bulletX: 2}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "shooter:shooter_up"
        snap: true
        snapCentered: true
    }
}

{Entity: "ShooterDown"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "shooter_down"}
        Script: {filename: "shooter.sv", script: {bullet: "DartDown", bulletY: 8, bulletX: 2}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "shooter:shooter_down"
        snap: true
        snapCentered: true
    }
}

{Entity: "ShooterLeft"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "shooter_left"}
        Script: {filename: "shooter.sv", script: {bullet: "DartLeft", bulletX: -12, bulletY: 2}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "shooter:shooter_left"
        snap: true
        snapCentered: true
    }
}

{Entity: "ShooterRight"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "shooter_right"}
        Script: {filename: "shooter.sv", script: {bullet: "DartRight", bulletX: 12, bulletY: 2}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "shooter:shooter_right"
        snap: true
        snapCentered: true
    }
}

{Entity: "DartUp"
    Components: {
        Location: {width: 3, height: 16}
        Movement: {vy: -240}
        PlatformClipped: {}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "dart_up1"}
        Script: {filename: "dart.sv"}
    }
}

{Entity: "DartDown"
    Components: {
        Location: {width: 3, height: 16}
        Movement: {vy: 240}
        PlatformClipped: {}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "dart_down1"}
        Script: {filename: "dart.sv"}
    }
}

{Entity: "DartLeft"
    Components: {
        Location: {width: 16, height: 3}
        Movement: {vx: -240}
        PlatformClipped: {}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "dart_left1"}
        Script: {filename: "dart.sv"}
    }
}

{Entity: "DartRight"
    Components: {
        Location: {width: 16, height: 3}
        Movement: {vx: 240}
        PlatformClipped: {}
        Collidable: {}
        LethalToPlayer: {}
        Visible: {lib: "shooter", frame: "dart_right1"}
        Script: {filename: "dart.sv"}
    }
}

{Entity: "SpearUp"
    Components: {
        Location: {width: 14, height: 14}
        Collidable: {}
        LethalToPlayer: {script: {enabled: false}}
        Visible: {lib: "spear", frame: "spear_up1"}
        Script: {filename: "spear.sv", script: {dirY: -1}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "spear:spear_up2"
        snap: true
        snapCentered: true
    }
}

{Entity: "SpearDown"
    Components: {
        Location: {width: 14, height: 14}
        Collidable: {}
        LethalToPlayer: {script: {enabled: false}}
        Visible: {lib: "spear", frame: "spear_down1"}
        Script: {filename: "spear.sv", script: {dirY: 1}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "spear:spear_down2"
        snap: true
        snapCentered: true
    }
}

{Entity: "SpearLeft"
    Components: {
        Location: {width: 14, height: 14}
        Collidable: {}
        LethalToPlayer: {script: {enabled: false}}
        Visible: {lib: "spear", frame: "spear_left1"}
        Script: {filename: "spear.sv", script: {dirX: -1}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "spear:spear_left2"
        snap: true
        snapCentered: true
    }
}

{Entity: "SpearRight"
    Components: {
        Location: {width: 14, height: 14}
        Collidable: {}
        LethalToPlayer: {script: {enabled: false}}
        Visible: {lib: "spear", frame: "spear_right1"}
        Script: {filename: "spear.sv", script: {dirX: 1}}
    }
    Attributes: {
        gridsnap: true
    }
    Tool: {
        icon: "spear:spear_right2"
        snap: true
        snapCentered: true
    }
}

]