[

// ********************************************************************************************** //
// * PROPS                                                                                      * //
// ********************************************************************************************** //

{Entity: "Light"
    Components: {
        Location: {width: 64, height: 64}
        Light: {shape: "point", layer: 2, color: "#ffffff", fill: true, diffuse: 0.3}
        EditorVisible: {lib: "ked", frame: "entity-light"}
        Script: {filename: "lightswitchable.sv"}
    }
    Attributes: {
        resizableX: true
        resizableY: true
        minWidth: 16
        minHeight: 16

        editorAttributes: ["lightOn", "lightColor", "lightDiffuse", "lightLayer", "shadows"]
    }
    Tool: {
        icon: "ked:tool-light"
        snap: false
        snapCentered: false
    }
}

{Entity: "Sunlight"
    Components: {
        Location: {width: 128, height: 128}
        EditorVisible: {lib: "ked", frame: "entity-sunlight"}
        Light: {shape: "area", layer: 3, color: "#ffffff", diffuse: 0, fill: true, shadows: true}
    }
    Attributes: {
        resizableX: true
        resizableY: true
        minWidth: 32
        minHeight: 32
        gridsnap: true

        editorAttributes: ["lightColor", "lightAngle", "lightDiffuse", "lightLayer"]
    }
    Tool: {
        icon: "ked:tool-sunlight"
        snap: true
    }
}

{Entity: "BlueSocket"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Visible: {lib: "sprites", frame: "socketblue1", zOrder: -100}
        Script: {filename: "socket.sv", script: {key: "blueGem", onFrame: "socketblue2"}}
    }
    Attributes: {
        gridsnap: true

        switchOn: false
        connections: []     // entities to receive Switched messages
    }
    Tool: {
        icon: "sprites:socketblue1"
        snap: true
        snapCentered: true
    }
}

{Entity: "GreenSocket"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Visible: {lib: "sprites", frame: "socketgreen1", zOrder: -100}
        Script: {filename: "socket.sv", script: {key: "greenGem", onFrame: "socketgreen2"}}
    }
    Attributes: {
        gridsnap: true

        switchOn: false
        connections: []     // entities to receive Switched messages
    }
    Tool: {
        icon: "sprites:socketgreen1"
        snap: true
        snapCentered: true
    }
}

{Entity: "RedSocket"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Visible: {lib: "sprites", frame: "socketred1", zOrder: -100}
        Script: {filename: "socket.sv", script: {key: "redGem", onFrame: "socketred2"}}
    }
    Attributes: {
        gridsnap: true

        switchOn: false
        connections: []     // entities to receive Switched messages
    }
    Tool: {
        icon: "sprites:socketred1"
        snap: true
        snapCentered: true
    }
}

{Entity: "YellowSocket"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Visible: {lib: "sprites", frame: "socketyellow1", zOrder: -100}
        Script: {filename: "socket.sv", script: {key: "yellowGem", onFrame: "socketyellow2"}}
    }
    Attributes: {
        gridsnap: true

        switchOn: false
        connections: []     // entities to receive Switched messages
    }
    Tool: {
        icon: "sprites:socketyellow1"
        snap: true
        snapCentered: true
    }
}

{Entity: "Switch1"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Visible: {lib: "sprites", frame: "switch1-off", zOrder: -100}
        Script: {filename: "switch.sv", script: {onFrame: "switch1-on", offFrame: "switch1-off"}}
    }
    Attributes: {
        gridsnap: true
        editorAttributes: ["switchOn"]

        switchOn: false
        connections: []     // entities to receive Switched messages
    }
    Tool: {
        icon: "sprites:switch1-off"
        snap: true
        snapCentered: true
    }
}

{Entity: "Switch2"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Visible: {lib: "sprites", frame: "switch2-off", zOrder: -100}
        Script: {filename: "switch.sv", script: {onFrame: "switch2-on", offFrame: "switch2-off"}}
    }
    Attributes: {
        gridsnap: true
        editorAttributes: ["switchOn"]

        switchOn: false
        connections: []     // entities to receive Switched messages
    }
    Tool: {
        icon: "sprites:switch2-off"
        snap: true
        snapCentered: true
    }
}

{Entity: "Bridge"
    Components: {
        Location: {width: 80, height: 16}
        Movement: {}
        Solid: {mass: 5, solid: true}
        Visible: {lib: "sprites", frame: "bridge-closed", layer: 2, zOrder: -100}
        Script: {filename: "bridge.sv"}
    }
    Attributes: {
        resizableX: true
        minWidth: 80
        gridsnap: true
        editorAttributes: ["open"]

        open: false
    }
    Tool: {
        icon: "ked:tool-bridge"
        snap: true
        snapCenteredX: false
        snapCenteredY: true
    }
}

{Entity: "Door"         // Teleporting doorway
    Components: {
        Location: {width: 32, height: 32}
        Collidable: {}
        EditorVisible: {lib: "ked", frame: "entity-door"}
        Script: {filename: "doorway.sv"}
    }
    Attributes: {
        gridsnap: true

        connections: []         // used to draw the connection
        destination: null       // the target entity to teleport to
    }
    Tool: {
        icon: "ked:tool-door"
        snap: true
        snapCentered: false
    }
}

{Entity: "LevelExit"
    Components: {
        Location: {width: 32, height: 32}
        Collidable: {}
        EditorVisible: {lib: "ked", frame: "entity-exit"}
        Script: {filename: "levelexit.sv"}
    }
    Attributes: {
        resizableX: true
        resizableY: true
        minWidth: 32
        minHeight: 32
        gridsnap: true
    }
    Tool: {
        icon: "ked:tool-exit"
        snap: true
        snapCentered: false
    }
}

{Entity: "Lift"
    Components: {
        Location: {width: 42, height: 9}
        Movement: {vxMax: 100, vyMax: 100}
        Solid: {mass: 5, top: true}
        Visible: {lib: "sprites", frame: "lift-down1", layer: 2, zOrder: -50}
        Script: {filename: "lift.sv"}
    }
    Attributes: {
        gridsnap: true

        connections: []     // lift path connected in the editor
        nextPath: null      // next lift path to move toward
    }
    Tool: {
        icon: "ked:tool-lift"
        snap: true
        snapCentered: true
    }
}

{Entity: "LiftPath"
    Components: {
        Location: {width: 16, height: 16}
        EditorVisible: {lib: "ked", frame: "entity-liftpath"}
        Script: {filename: "liftpath.sv"}
    }
    Attributes: {
        gridsnap: true
        editorAttributes: ["locked"]

        locked: false           // path point locked; lifts stop here
        connections: []         // next path point in the editor
        nextPath: null          // next path point (connections[1])
    }
    Tool: {
        icon: "ked:tool-liftpath"
        snap: true
        snapCentered: true
    }
}

{Entity: "LockedDoor"
    Components: {
        Location: {width: 16, height: 48}
        Movement: {}
        Solid: {mass: 5, solid: true}
        Visible: {lib: "sprites", frame: "door1", layer: 3, zOrder: -100}
        Script: {filename: "lockeddoor.sv"}
    }
    Attributes: {
        resizableY: true
        minHeight: 48
        gridsnap: true
    }
    Tool: {
        icon: "ked:tool-lockeddoor"
        snap: true
        snapCentered: true
    }
}

{Entity: "Pole"
    Components: {
        Location: {width: 16, height: 48}
        Collidable: {}
        EditorVisible: {lib: "ked", frame: "entity-pole"}
        Climbable: {}
    }
    Attributes: {
        resizableY: true
        minHeight: 32
        gridsnap: true
    }
    Tool: {
        icon: "ked:tool-pole"
        snap: true
        snapCentered: true
    }
}

{Entity: "StunnerShot"
    Components: {
        Location: {width: 16, height: 16}
        Collidable: {}
        Movement: {}
        PreciseClipped: {}
        Visible: {lib: "sprites", frame: "phaze1", zOrder: 100}
        Light: {radius: 128, layer: 2, color: "#44ff44", diffuse: 0.5}
        Animation: {}
        Lethal: {script: {victim: "Enemy"}}
        Script: {filename: "shot.sv", script: {shooter: "Player"}}
    }
}

{Entity: "Emitter"
    Components: {
        Location: {width: 16, height: 16}
        EditorVisible: {lib: "ked", frame: "entity-emitter"}
        Script: {filename: "emitter.sv"}
    }
    Attributes: {
        editorAttributes: ["enabled", "emitterName", "emitLayer", "emitAngle", "emitRate"]

        enabled    : true
        emitterName: ""
        emitLayer  : 1
        emitAngle  : 0 
        emitRate   : 50
    }
    Tool: {
        icon: "ked:tool-emitter"
        snap: true
        snapCentered: true
    }
}

]
