// A specific-use script used by the Fence entity to erase a blocking tile
// under the Fence when the fence's associated level has been beaten.
//
// Entity Attribute    Type      Description
// ----------------    ----      -----------
// world               string    The name of the associated level.
//
{

script: {
    // The Fence entity self-destructs after a specified level has
    // been beaten. The level that triggers the self-destruction is
    // specified in the "world" attribute.
    member OnPlayStarted()
        if game.lastWin = this.entity.world and game.lastWin != "" then
            this.entity.Destroy();
        end if;
    end function
}

}