// A specific-use script used by the Flag entity.
//
{

script: {
    member OnSpawned()
        PlaySound("flag1");
        this.entity.finalX := this.entity.x;
        this.entity.finalY := this.entity.y;
        this.entity.x -= 30;                // fly distance
        this.entity.y += 30;                //
        this.entity.vx := 40;
        this.entity.vy := -40;
    end function

    // Stops the flag movement when it reaches its final destination.
    // Due to rounding errors, it won't be in exactly the right place
    // after flying for a fixed period of time.
    member StopFlying()
        this.entity.x := this.entity.finalX;
        this.entity.y := this.entity.finalY;
        this.entity.vx := 0;
        this.entity.vy := 0;
    end function

    // Plays the planting flag sound and switches to the stationary,
    // planted flag animation.
    member PlantFlag()
        PlaySound("flag2");
        this.entity.frame := "flag1";
    end function
}

timers: {
    StopFlying: 750     // 750 ms flight time
    PlantFlag: 1050     // 300 ms planting time (1050ms - 750ms)
}

}
