// A specific-use script used by the LevelEntrance entity that changes levels
// when activated. The level will not be enterable again once it has been
// beaten, unless the 'replayable' entity attribute is True.
//
// Entity Attribute    Type       Description
// ----------------    ----       -----------
// world               string     The associated world to enter.
// replayable          boolean    Set 'True' to allow a level to always be playable.
//
{

script: {
    // Only enter the level when the entrance is activated and the level hasn't
    // been beaten yet, or is replayable (e.g. the BWB Megarocket).
    member OnActivateAtWill()
        if !(this.entity.world in game.completed) or this.entity.replayable then
            EnterLevel(this.entity.world);
        end if;
    end function
}

}
