// The AI for a shot. It sends "HitByShot" messages to every entity it collides
// with, and then simply destructs when it collides with a wall or a
// ShotBlocker of a matching type.
//
// Variable    Type       Description
// --------    ----       -----------
// shooter     string     The entity type of the shooter (e.g. Player, Enemy);
//                        used by the ShotBlocker component.
//
{

script: {
    member OnCollided(args : map)
        args.eid.Send("HitByShot", {eid: this.entity, shooter: this.shooter});
    end function

    member OnHitWall()
        this.entity.Destroy();
    end function

    member OnShotBlocked()
        this.entity.Destroy();
    end function

    member OnDestruct()
        PlaySound("shot_hit");
        ParticleBurst("StunnerBlast1", this.entity.x, this.entity.y, this.entity.layer, 1);
        ParticleBurst("StunnerBlast2", this.entity.x, this.entity.y, this.entity.layer, 4);
    end function

    shooter: null           // Required
}

}
