// The behavioral script of the Spear entities.
//
// Variable     Type       Description
// --------     ----       -----------
// dirX         number     The direction the spear moves in the X axis (-1, 0, or 1)
// dirY         number     The direction the spear moves in the Y axis (-1, 0, or 1)
//
{

script: {

    member Attack()
        if !game.editor then
            this.Move();
        end if;
    end function

    member Move()
        if this.state < 3 then
            this.entity.x += this.dirX * 16;
            this.entity.y += this.dirY * 16;
        else
            this.entity.x -= this.dirX * 16;
            this.entity.y -= this.dirY * 16;
        end if;

        this.state += 1;
        if this.state <= 4 then
            if this.state = 2 then
                this.entity.Send("Lethal", {enabled: true});
            end if;
            this.SetTimer("Move", 75);
        else
            this.state := 1;
            this.entity.Send("Lethal", {enabled: false});
        end if;

        this.entity.frame := "spear_" & (this.dirX < 0 ? "left" : (this.dirX > 0 ? "right" : (this.dirY < 0 ? "up" : "down"))) & (this.state = 4 ? 2 : this.state);
    end function

    dirX : 0                // Required
    dirY : 0                // Required
    state: 1
}

timers: {
    Attack: {time: 2100, repeat: true}
}

}
