// A component used exclusively by the Switch entities that sends a "Switched"
// message to its connections when it's activated at will by the player.
//
{

script: {
    member OnConnect(args : map)
        if !(args.eid in this.entity.connections) then
            this.entity.connections &= [args.eid];
        end if;
    end function

    member OnDisconnect(args : map)
        this.entity.connections -= [args.eid];
    end function

    member OnActivateAtWill(args : map)
        args.eid.Send("Switching");
        this.entity.switchOn := !this.entity.switchOn;
    end function

    member OnAttributeChanged(args : map)
        if args.name = "switchOn" then
            this.entity.frame := args.value ? this.onFrame : this.offFrame;
            PlaySound("click.wav");
            for i is 1 to length(this.entity.connections) loop
                this.entity.connections[i].Send("Switched", {on: args.value});
            end loop;
        end if;
    end function

    onFrame : null              // Required
    offFrame: null              // Required
}

}